#include <iostream>

using namespace std;
/*
Definition of a linked list (or chain)

In contrast to an array, that allocates memory for all its elements as one block of memory, a linked list allocates space for each element separately in its own block of memory called a "linked list element" or "node". The list gets its overall structure by using pointers to connect all its nodes together like the links in a chain.

Each node contains two fields: a "data" field to store whatever element type the list holds for its client, and a "next" field which is a pointer used to link one node to the next node. Each node is allocated in the heap.
The first node contains a pointer to the second node. The second node contains a pointer to the third node, ... and so on. The last node in the list has its next field set to NULL to mark the end of the list

Additional info can be easily googled using phrase "linked list c++"
*/

// A typical node structure.
// Each node contains a single client data element and a pointer to the next node in the list:

struct node{
    int data;
    node* link;
};

// create new node object and return its pointer
node* createNode(int dataToStore){
    node* newNode = new node();
    newNode->data = dataToStore;
    newNode->link = NULL;
    return newNode;
}

// add new node to the beginning of the linked list
// TODO why do we use first argument with type "node**"? can we use only type "node*"? Will it be enough? Try it!
// Put your explanations as comment to this function.
void pushInFront(node** head, int dataToStore){
    // create new node to add
    node* nodeToAdd = createNode(dataToStore);
    
    if (*head!=NULL){
        nodeToAdd->link = *head;
    }
    *head = nodeToAdd;
    return;
}

// add new node to the end of the linked list
// TODO implement this function
void pushBack(node** head, int dataToStore){
    
    return;
}

// return size of the list
int getSize(node* head){
    int nNodes = 0;
    node* tmpNode = head;
    while (tmpNode!=NULL){
        tmpNode = tmpNode->link;
        nNodes++;
    }
    return nNodes;
}

// delete a node at a specific position 
// TODO implement this function
void deleteNode(node** head, unsigned int nodePosition){
    
}


void printLinkedList(node* head){
    node* tempNode = head;   
    cout << "List [size " << getSize(head) << "]: ";
    while (tempNode!=NULL){
        cout << tempNode->data << " ";
        tempNode = tempNode->link;
    }
    cout << endl;
}

// delete all nodes and free all memory
// TODO find a bug
void deleteList(node** head){
    if (*head==NULL) return;
    cout << "list size: " << getSize(*head) << endl;
    node* tempNode = *head;
    while (tempNode->link!=NULL){
        node* tempNode2 = tempNode->link;
        delete tempNode;
        cout << "delete node" << endl;
        tempNode = tempNode2;
    }
    *head = NULL;
    return;
}

// function return pointer to a head of the new list
// all nodes from copied list should have different addresses wrt the original list
// TODO implement this function
node* copyList(node* head){
    node* newListHead = NULL;

    return newListHead;
}

void printNodeAddresses(node* head){
    node* tempNode = head;   
    while (tempNode!=NULL){
        cout << tempNode << " ";
        tempNode = tempNode->link;
    }
    cout << endl;
}

int main(int argc, char* argv[]){
 
    node* linkedList = NULL;
    
    unsigned int nNumbersToPushInFront;
    cout << "How many numbers push to the FRONT?" << endl;
    cin >> nNumbersToPushInFront;
        
    for (int i=0; i<nNumbersToPushInFront; i++){
        int tmpInt;
        cout << "Enter the number:" << endl;
        cin >> tmpInt;
        pushInFront(&linkedList, tmpInt);
        printLinkedList(linkedList);
    }
    
    unsigned int nNumbersToPushBack;
    cout << "How many numbers push to the BACK?" << endl;
    cin >> nNumbersToPushBack;
        
    for (int i=0; i<nNumbersToPushBack; i++){
        int tmpInt;
        cout << "Enter the number:" << endl;
        cin >> tmpInt;
        pushBack(&linkedList, tmpInt);
        printLinkedList(linkedList);
    }
    
    unsigned int nNumbersToDelete;
    cout << "How many numbers to delete?" << endl;
    cin >> nNumbersToDelete;
    
    for (int i=0; i<nNumbersToDelete; i++){
        int nodeSize = getSize(linkedList);
        if (nodeSize==0) break;
        
        int tmpInt;
        cout << "Enter position:" << endl;
        cin >> tmpInt;
        deleteNode(&linkedList, tmpInt);
        printLinkedList(linkedList);
    }
    
    node* copiedList = copyList(linkedList);
    
    cout << endl << "Check copying functionality. Addresses of nodes of two lists should be different." << endl;
    cout << "[linkedList]\tsize: " << getSize(linkedList) << "; addresses: ";
    printNodeAddresses(linkedList);
    cout << "[copiedList]\tsize: " << getSize(copiedList) << "; addresses: ";
    printNodeAddresses(copiedList);
    
    cout << endl << "Delete lists and free all memory..." << endl << "Linked ";
    deleteList(&linkedList);
    cout << "Linked list pointer: " << linkedList << endl << endl << "Copied ";
    deleteList(&copiedList);
    cout << "Copied list pointer: " << copiedList << endl;
    
    return 0;
}